/*
 * NoGray JavaScript Library
 *
 * Copyright (c), All right reserved
 * Gazing Design - http://www.NoGray.com
 * Free to use as long as the copyrights
 * notice is not removed. For customization
 * or installation service, please contact
 * us at http://www.nogray.com/contact.php
 */
 
(function($){
	if (location.href.indexOf('no-ng-scroll') != -1) return;
	$(function(){
		var thumb_height_func = false;
		// if you template uses a function to set the thumbnails height,
		// make sure to use the correct function name. Otherwise, commented it out
		var thumb_height_func = setProductListHeights;
		
		// function to run after the products are loaded
		var run_after_load = function(products_ul, pg_number){};
		
		// hide or show the pagintation
		var hide_pagintation = false;
		
		// general settings about the template
		var max_auto_load = 10;
		
		// div id that holds the comparison form and products
		var parent_div = '#CategoryContent';
		
		// element tag that holds the products
		var products_parent_tag = 'ul';
		var products_parent_class = 'ProductList';
		var products_tag = 'li';
		
		// prefix for each css class page (e.g. page-#) where # is the page number
		var css_prefix = '.page-';
		
		// paging div class name
		var paging_class_name = '.CategoryPagination';
		
		// paging list element tags
		var paging_ul = 'ul';
		var paging_li = 'li';
		var active_page_class = '.ActivePage';
		
		// endless loading div class
		var paging_class = '.endless-paging';
		var load_more_class = '.endless-load-more';
		var loading_class = '.endless-loading';
		var load_more_text = 'load more';
		
		// show page numbers next to each new set
		var show_page_numbers = true;
		
		// quickview button object
		var quickbutton = {
			buttonText: "Quick View",
			buttonColor: "#f7f7f7",
			gradientColor: "#dcdbdb",
			textColor: "#000000"
		};
		
		// DO NOT change anything below this unless you know what you are doing
		
		// page number class name
		var page_number_class = '.page-number';
		var outof_pages_class = '.outof-pages';
		var page_number_prefix = 'Page ';
		var outof_number_prefix = ' of ';
		
		// Session key to remember loaded page. It should be unique to the category and sort options
		var url = location.href.replace('http://', '').replace('https://', '');
		if (url.indexOf('#') != -1) url = url.substr(0, url.indexOf('#'));
		if (url.indexOf('/') != -1) url = url.substr(url.indexOf('/'));
		var session_key = url;
		
		// scripts variables
		var pages_arr = [];
		var current_page = 1;
		var num_loads = 1;
		var processing_ajax = false;
		var loaded_pages = [];
		var paging_link = '';
		var scroll_position = 0;
		
		if (window.sessionStorage){
			var session = sessionStorage.getItem(session_key);
			if (session) {
				loaded_pages = JSON.parse(session);
				pages_arr = JSON.parse(sessionStorage.getItem(session_key+'pages'));
				paging_link = sessionStorage.getItem(session_key+'page_link');
				scroll_position = sessionStorage.getItem(session_key+'scroll_position');
				if (scroll_position > 0) {
					setTimeout(function(){
						$(window).scrollTop(scroll_position);
						sessionStorage.setItem(session_key+'scroll_position', 0);
					}, 500);
				}
			}
		}
		
		var clsnm = function(nm){
			return nm.replace('.', '');
		};
		
		var total_pages = function(){
			if (pages_arr.length) return pages_arr.length - 1;
			else return 1;
		};
		
		var get_page = function (num){
			// check if we need to refetch data
			if (num < 1) return;
			if (pages_arr[num] == null) return;
			if (processing_ajax) return;
			if ($(css_prefix+num).length) return;
			// ajax get the page content
			processing_ajax = true;
			if (location.protocol == 'https:') pages_arr[num] = pages_arr[num].replace('http:', 'https:');
			else pages_arr[num] = pages_arr[num].replace('https:', 'http:');
			
			if (location.href.indexOf('www.')  == -1) pages_arr[num] = pages_arr[num].replace('www.', '');

			$.get(pages_arr[num], function(data){
				processing_ajax = false;
				var data = process_data(data);
				var dv = $('<div></div>');
				dv.append($(data).clone());
				loaded_pages.push({page:num, elm:dv.html()});
				dv.remove();
				insert_page(data, num);
			});
		};
		
		// processing the HTML document
		var process_data = function(html){
			// removing the loading animation
			$(paging_class).removeClass(clsnm(loading_class));
			// creating the HTML document
			var html = $(html);
			
			// processing the paging
			if ($(paging_class_name, html).length){
				process_paging($(paging_class_name, html).first());
			}
			
			return $(parent_div+' '+products_parent_tag+'.'+clsnm(products_parent_class), html).last();
		};
		
		var insert_page = function(elm, num){
			// setting the number of pages loaded
			num_loads++;
			
			process_ul(elm, num);
			
			var added = false;
			if (num == 1) $(paging_class).first().remove();
			if (num == total_pages()) $(paging_class).last().remove();
			
			$(parent_div+' '+products_parent_tag+'.'+clsnm(products_parent_class)).each(function(k, ul){
				var pgnum = parseInt($(ul).data('page-number'), 10);
				if (pgnum > num){
					$(ul).before(elm);
					var h = $(elm).outerHeight(true);
					scroll_to(h, true);
					added = true;
					return false;
				}
				else if (pgnum == num - 1){
					$(ul).after(elm);
					added = true;
					return false;
				}
			});
			
			if (!added) $(parent_div+' '+products_parent_tag+'.'+clsnm(products_parent_class)).last().after(elm);
			if (show_page_numbers){
				var dv = $('<div class="'+clsnm(page_number_class)+'" data-page-number="'+num+'"><a name="page'+num+'"></a>'+page_number_prefix+num+'<span class="'+clsnm(outof_pages_class)+'">'+outof_number_prefix+(total_pages())+'</span></div>');
				$(elm).prepend(dv);
			}
			
			run_after_load(elm, num);
			if (thumb_height_func){
				setTimeout(thumb_height_func, 100);	
			}
		};
		
		// adding the class name and data to the ul
		// plus clearing the bottom to get the correct height
		var process_ul = function(elm, num){
			var cls_nm = clsnm(css_prefix);
			$(elm).addClass(cls_nm+num).data('page-number', num);
			$(elm).append('<'+products_tag+' style="height:1px !important; float:none !important; clear:both !important; overflow:hidden !important; min-height:0px !important; margin:0px !important; padding:0px !important; border:none !important; visiblity:hidden !important;">&nbsp;</'+products_tag+'>');
			
			// check if the quickview function is defined.
			try {
				$(".QuickView", elm).quickview(quickbutton);
			}
			catch(e) {}

		};
		
		// pagintation link click event
		var pagintation_click = function(evt){
			var num = parseInt($(this).text(), 10);
			for (var i=0; i<loaded_pages.length; i++){
				if (loaded_pages[i].page == num){
					evt.preventDefault();
					location.hash = 'page'+num;	
				}
			}
		};
		
		// process the paging list to get the links
		var process_paging = function(elm, cur){
			$(paging_li, elm).each(function(k, elm) {
				var arr = elm.getElementsByTagName('a');
				if (arr.length){
					var pg_num = parseInt($(arr[0]).text(), 10);
					if (!isNaN(pg_num)){
						if ((pg_num == 2) && (paging_link == '')){
							paging_link = arr[0].href.replace('page=2', 'page=#');
						}
						pages_arr[pg_num] = (arr[0].href);
					}
				}
				else {
					if (cur) {
						current_page = parseInt($(elm).text(), 10);
					}
				}
			});
			
			if (!hide_pagintation) {
				$(paging_class_name+' '+active_page_class).each(function(){
					var obj = $(this);
					var num = obj.text();
					obj.removeClass(clsnm(active_page_class));
					obj.html('<a href="'+paging_link.replace('page=#', 'page='+num)+'">'+num+'</a>');
					$('a', obj).click(pagintation_click);
				});
			}
			
			var to_add = [];
			for(var i=1; i<pages_arr.length; i++){
				if (pages_arr[i]) {
					var num = i;
					var found = false;
					$(paging_class_name+' '+paging_li).each(function(){
						var arr = this.getElementsByTagName('a');
						if (arr.length){
							var pg_num = parseInt($(arr[0]).text(), 10);
							if (!isNaN(pg_num)){
								if (pg_num == num) {
									found = true;
									return false;	
								}
							}
						}
					});
					
					if (!found) to_add[i] = paging_link.replace('page=#', 'page='+num);
				}
			}
			
			for(var i=1; i<to_add.length; i++){
				if (to_add[i]) {
					$(paging_class_name+' '+paging_li).each(function(){
						var arr = this.getElementsByTagName('a');
						if (arr.length){
							var pg_num = parseInt($(arr[0]).text(), 10);
							if (!isNaN(pg_num)){
								if (pg_num+1 == i){
									var li = $('<'+paging_li+'><a href="'+to_add[i]+'">'+i+'</a></li>');
									$(this).after(li);
									$('a', li).click(pagintation_click);
								}
							}
						}
					});	
				}
			}
		};
		
		// adding the loading divs
		var add_loading_div = function(elm, dir){
			var dv = $('<div class="'+clsnm(paging_class)+'"><div class="'+clsnm(load_more_class)+'">'+load_more_text+'</div></div>');
			if (dir == 'before'){
				dv.click(function(evt){
					var pg = $(parent_div+' '+products_parent_tag+'.'+clsnm(products_parent_class)).first().data('page-number');
					pg = parseInt(pg, 10);
					if (isNaN(pg)) return;
					get_page(pg - 1);
					$(this).addClass(clsnm(loading_class));
				});
			}
			else {
				dv.click(function(evt){
					var pg = $(parent_div+' '+products_parent_tag+'.'+clsnm(products_parent_class)).last().data('page-number');
					pg = parseInt(pg, 10);
					if (isNaN(pg)) return;
					get_page(pg + 1);
					$(this).addClass(clsnm(loading_class));
				});
			}
			$(elm).parent().after(dv);
		}
		
		// function to scroll the document when adding pages above current page
		var scroll_to = function(tp, add){
			if (add) tp += $(window).scrollTop();
			$(window).scrollTop(tp);
		};
		
		// getting the page links
		process_paging($(paging_class_name).first(), true);
		
		if (show_page_numbers){
			var dv = $('<div class="'+clsnm(page_number_class)+'" data-page-number="'+current_page+'"><a name="page'+current_page+'"></a>'+page_number_prefix+current_page+'<span class="'+clsnm(outof_pages_class)+'">'+outof_number_prefix+(total_pages())+'</span></div>');
			$(parent_div+' '+products_parent_tag+'.'+clsnm(products_parent_class)).first().prepend(dv);
		}
		
		// adding the "Load more" div
		if (current_page != 1) add_loading_div($(paging_class_name).first(), 'before');
		add_loading_div($(paging_class_name).last(), 'after');
		
		if (hide_pagintation) {
			$(paging_class_name).parent().remove();
		}
		else {
			$(paging_class_name+' a').click(pagintation_click);
		}
		
		// setting the current ul details
		var ini_products_ul = $(parent_div+' '+products_parent_tag+'.'+clsnm(products_parent_class)).first();
		
		// we need to remove the current page from the session variable
		for (var i=0; i<loaded_pages.length; i++){
			if (loaded_pages[i].page == current_page)
				loaded_pages.splice(i, 1);
		}
		
		// processing the current page
		var dv = $('<div></div>');
		dv.append(ini_products_ul.clone());
		loaded_pages.push({page:current_page, elm:dv.html()});
		dv.remove();
		process_ul(ini_products_ul, current_page);
		
		// loading session pages
		for (var i=0; i<loaded_pages.length; i++){
			if (loaded_pages[i].page != current_page)
				insert_page($(loaded_pages[i].elm), loaded_pages[i].page);
		}
		
		
		// caching the current loaded pages in session
		if (window.sessionStorage){
			$(window).bind('beforeunload', function() {
				sessionStorage.setItem(session_key, JSON.stringify(loaded_pages));
				sessionStorage.setItem(session_key+'pages', JSON.stringify(pages_arr));
				sessionStorage.setItem(session_key+'page_link', paging_link);
				sessionStorage.setItem(session_key+'scroll_position', $(window).scrollTop());
			});
		}
		
		// timeout to check if scroll ends
		var scroll_timeout = 0;
		$(window).scroll(function(evt){
			//return;
			if (num_loads > max_auto_load) return;
			clearTimeout(scroll_timeout);
			scroll_timeout = setTimeout(process_scroll, 10);
		});
		
		var process_scroll = function(){
			var pgdiv_ln = $(paging_class).length;
			if (pgdiv_ln == 0) return;
			
			var st = $(window).scrollTop();
			var h = $(window).height();	
			var ldt = $(paging_class).first().position().top;
			if ((ldt > st - h) && (ldt < st + h)) {
				$(paging_class).first().click();
			}
			
			if (pgdiv_ln > 1){
				var ldt = $(paging_class).last().position().top;
				if ((ldt > st) && (ldt < st + h)) {
					$(paging_class).last().click();
				}
			}
		};
	});
})(jQuery);